=== debian/changelog ===
libssh (0.8.0~20170825.94fa1e38-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 07 Feb 2018 11:35:23 +0000

libssh (0.8.0~20170825.94fa1e38-1) unstable; urgency=medium

  [ Laurent Bigonville ]
  * debian/watch: Verify the signature of the upstream tarball
  * debian/libssh-gcrypt-4.lintian-overrides: Adjust the overrides

  [ Matteo F. Vescovi ]
  * New upstream git snapshot (based on commit 94fa1e38) (Closes: #828413)
  * debian/patches/: patchset refreshed against snapshot release
  * debian/: symbols files refreshed for snapshot release
  * debian/control: bump OpenSSL b-dep to use 1.1 version
  * debian/copyright: entried updated
  * debian/copyright.in: drop useless file
  * debian/patches/: patchset updated
    - 2004-fix-upstream-version.patch added

 -- Laurent Bigonville <bigon@debian.org>  Wed, 13 Sep 2017 14:36:14 +0200
