=== debian/watch ===
version=4
opts="pgpmode=next,decompress" \
https://red.libssh.org/projects/libssh/files \
    /attachments/download/(?:\d+)/libssh-@ANY_VERSION@@ARCHIVE_EXT@ debian
opts="pgpmode=previous" \
https://red.libssh.org/projects/libssh/files \
    /attachments/download/(?:\d+)/libssh-@ANY_VERSION@.tar.asc previous
